#include <math.h>
#include "Character.hpp"
#include "Particle.hpp"
#include <stdio.h>
using namespace cg_engine;
using namespace std;

Character::Character(GLfloat x, GLfloat y, GLfloat z, GLfloat dim, int *mask, int masklen)
{
	int i;
	int j;

	for(i=0; i < 35; i++){
		for(j=0; j < masklen; j++){
			if(i == mask[j]){
				GLfloat xpos = x + (i % 5) * dim;
			       	GLfloat ypos = y + floor(i / 5) * dim;
				particles.push_back(new Particle(100, xpos, xpos + dim, ypos, ypos + dim, z, z + dim));
			}
		}
	}
}

Character::~Character()
{
	unsigned long int i;
	for(i = 0; i < particles.size(); i++){
		delete particles.at(i);
	}
}

void Character::draw()
{
	unsigned long int i;
	for(i = 0; i < particles.size(); i++){
		particles.at(i)->draw();
	}
}

void Character::update(double time)
{
	unsigned long int i;
	for(i = 0; i < particles.size(); i++){
		particles.at(i)->update(time);
	}
}

void Character::unify(double dx, double dy, double dz)
{
	unsigned long int i;
	for(i = 0;i < particles.size(); i++){
		particles.at(i)->unifydir(dx, dy, dz);
	}
}

void Character::noreborn()
{
	unsigned long int i;
	for(i = 0;i < particles.size(); i++){
		particles.at(i)->noreborn();
	}
}
