#pragma once
#include <GL/glew.h>
#include "CGengine.hpp"

namespace cg_engine {
	class RenderBuffer
	{
	public:
		RenderBuffer(int w, int h, int sy, int texnum, bool adddepth);
		~RenderBuffer();
		GLuint getFramebuffer();
		GLuint getRenderTexture(int index);
		void firstPass();
		void secondPass();
		void addShader(ShaderProgram *prg);
		void setFade(float f);
		void setKernelSize(int ks);
		void setVignette(float v);
		void setAvg(int s);
		bool getError();
		void setZoom(float z);
	private:
		GLuint framebuffer = 0;
		GLuint *renderTexture;
		GLuint depthbuffer;
		int width;
		int height;
		int starty;
		bool isError;
		int maxtexture;
		float fade;
		int kernelsize;
		int avg;
		float vignette;
		float zoom;
		ShaderProgram *postprocessing;
		Sprite *outsprite;
	};

}
