#pragma once
#include <iostream>
#include "CGengine.hpp"
#include "Character.hpp"
#include "PString.hpp"

using namespace cg_engine;

class Background: public Scene {
	public:
		Background(int w, int h);
		void show(double time);
	private:
		Particle      *particles[122];
		ShaderProgram *backgroundshader;
		Matrix         pmatrix;
};

class Begin: public Scene {
	public:
		Begin(int w, int h);
		void show(double time);
	private:
		PString       *begin;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createBegin();
};

class Fourteen: public Scene {
	public:
		Fourteen(int w, int h);
		void show(double time);
	private:
		PString       *fourteen;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createFourteen();
};

class Thirtytwo: public Scene {
	public:
		Thirtytwo(int w, int h);
		void show(double time);
	private:
		PString       *thirtytwo;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createThirtytwo();
};

class N158: public Scene {
	public:
		N158(int w, int h);
		void show(double time);
	private:
		PString       *n158;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createN158();
};

class N271: public Scene {
	public:
		N271(int w, int h);
		void show(double time);
	private:
		PString       *n271;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createN271();
};

class Million: public Scene {
	public:
		Million(int w, int h);
		void show(double time);
	private:
		PString       *million;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createMillion();
};

class Marioplex: public Scene {
	public:
		Marioplex(int w, int h);
		void show(double time);
	private:
		PString       *marioplex;
		ShaderProgram *starshader;
		Matrix        pmatrix;
		void createMarioplex();
};

class RandomNums: public Scene {
	public:
		RandomNums(int w, int h);
		void show(double time);
	private:
		PString       *rndnum;
		Character     *nums[10];
		ShaderProgram *starshader;
		Matrix         pmatrix;
		void createRandomNums();
};

class MyDemo: public Demo{
	public:
		MyDemo(int w, int h);
		void init();
};
